(* This file is generated by Why3's Coq driver *)
(* Beware! Only edit allowed sections below    *)
Require Import BuiltIn.
Require BuiltIn.
Require int.Int.
Require list.List.
Require list.Length.
Require list.Mem.
Require list.Append.

(* Why3 assumption *)
Definition unit := unit.

Axiom set : forall (a:Type), Type.
Parameter set_WhyType : forall (a:Type) {a_WT:WhyType a}, WhyType (set a).
Existing Instance set_WhyType.

Parameter mem: forall {a:Type} {a_WT:WhyType a}, a -> (set a) -> Prop.

(* Why3 assumption *)
Definition infix_eqeq {a:Type} {a_WT:WhyType a} (s1:(set a)) (s2:(set
  a)): Prop := forall (x:a), (mem x s1) <-> (mem x s2).

Axiom extensionality : forall {a:Type} {a_WT:WhyType a}, forall (s1:(set a))
  (s2:(set a)), (infix_eqeq s1 s2) -> (s1 = s2).

(* Why3 assumption *)
Definition subset {a:Type} {a_WT:WhyType a} (s1:(set a)) (s2:(set
  a)): Prop := forall (x:a), (mem x s1) -> (mem x s2).

Axiom subset_refl : forall {a:Type} {a_WT:WhyType a}, forall (s:(set a)),
  (subset s s).

Axiom subset_trans : forall {a:Type} {a_WT:WhyType a}, forall (s1:(set a))
  (s2:(set a)) (s3:(set a)), (subset s1 s2) -> ((subset s2 s3) -> (subset s1
  s3)).

Parameter empty: forall {a:Type} {a_WT:WhyType a}, (set a).

(* Why3 assumption *)
Definition is_empty {a:Type} {a_WT:WhyType a} (s:(set a)): Prop :=
  forall (x:a), ~ (mem x s).

Axiom empty_def1 : forall {a:Type} {a_WT:WhyType a}, (is_empty (empty : (set
  a))).

Axiom mem_empty : forall {a:Type} {a_WT:WhyType a}, forall (x:a), ~ (mem x
  (empty : (set a))).

Parameter add: forall {a:Type} {a_WT:WhyType a}, a -> (set a) -> (set a).

Axiom add_def1 : forall {a:Type} {a_WT:WhyType a}, forall (x:a) (y:a),
  forall (s:(set a)), (mem x (add y s)) <-> ((x = y) \/ (mem x s)).

Parameter remove: forall {a:Type} {a_WT:WhyType a}, a -> (set a) -> (set a).

Axiom remove_def1 : forall {a:Type} {a_WT:WhyType a}, forall (x:a) (y:a)
  (s:(set a)), (mem x (remove y s)) <-> ((~ (x = y)) /\ (mem x s)).

Axiom add_remove : forall {a:Type} {a_WT:WhyType a}, forall (x:a) (s:(set
  a)), (mem x s) -> ((add x (remove x s)) = s).

Axiom remove_add : forall {a:Type} {a_WT:WhyType a}, forall (x:a) (s:(set
  a)), ((remove x (add x s)) = (remove x s)).

Axiom subset_remove : forall {a:Type} {a_WT:WhyType a}, forall (x:a) (s:(set
  a)), (subset (remove x s) s).

Parameter union: forall {a:Type} {a_WT:WhyType a}, (set a) -> (set a) -> (set
  a).

Axiom union_def1 : forall {a:Type} {a_WT:WhyType a}, forall (s1:(set a))
  (s2:(set a)) (x:a), (mem x (union s1 s2)) <-> ((mem x s1) \/ (mem x s2)).

Parameter inter: forall {a:Type} {a_WT:WhyType a}, (set a) -> (set a) -> (set
  a).

Axiom inter_def1 : forall {a:Type} {a_WT:WhyType a}, forall (s1:(set a))
  (s2:(set a)) (x:a), (mem x (inter s1 s2)) <-> ((mem x s1) /\ (mem x s2)).

Parameter diff: forall {a:Type} {a_WT:WhyType a}, (set a) -> (set a) -> (set
  a).

Axiom diff_def1 : forall {a:Type} {a_WT:WhyType a}, forall (s1:(set a))
  (s2:(set a)) (x:a), (mem x (diff s1 s2)) <-> ((mem x s1) /\ ~ (mem x s2)).

Axiom subset_diff : forall {a:Type} {a_WT:WhyType a}, forall (s1:(set a))
  (s2:(set a)), (subset (diff s1 s2) s1).

Parameter choose: forall {a:Type} {a_WT:WhyType a}, (set a) -> a.

Axiom choose_def : forall {a:Type} {a_WT:WhyType a}, forall (s:(set a)),
  (~ (is_empty s)) -> (mem (choose s) s).

Parameter cardinal: forall {a:Type} {a_WT:WhyType a}, (set a) -> Z.

Axiom cardinal_nonneg : forall {a:Type} {a_WT:WhyType a}, forall (s:(set a)),
  (0%Z <= (cardinal s))%Z.

Axiom cardinal_empty : forall {a:Type} {a_WT:WhyType a}, forall (s:(set a)),
  ((cardinal s) = 0%Z) <-> (is_empty s).

Axiom cardinal_add : forall {a:Type} {a_WT:WhyType a}, forall (x:a),
  forall (s:(set a)), (~ (mem x s)) -> ((cardinal (add x
  s)) = (1%Z + (cardinal s))%Z).

Axiom cardinal_remove : forall {a:Type} {a_WT:WhyType a}, forall (x:a),
  forall (s:(set a)), (mem x s) -> ((cardinal s) = (1%Z + (cardinal (remove x
  s)))%Z).

Axiom cardinal_subset : forall {a:Type} {a_WT:WhyType a}, forall (s1:(set a))
  (s2:(set a)), (subset s1 s2) -> ((cardinal s1) <= (cardinal s2))%Z.

Axiom subset_eq : forall {a:Type} {a_WT:WhyType a}, forall (s1:(set a))
  (s2:(set a)), (subset s1 s2) -> (((cardinal s1) = (cardinal s2)) ->
  (infix_eqeq s1 s2)).

Axiom cardinal1 : forall {a:Type} {a_WT:WhyType a}, forall (s:(set a)),
  ((cardinal s) = 1%Z) -> forall (x:a), (mem x s) -> (x = (choose s)).

(* Why3 assumption *)
Fixpoint elements {a:Type} {a_WT:WhyType a} (l:(list a)) {struct l}: (set
  a) :=
  match l with
  | Init.Datatypes.nil => (empty : (set a))
  | (Init.Datatypes.cons x r) => (add x (elements r))
  end.

Axiom elements_mem : forall {a:Type} {a_WT:WhyType a}, forall (x:a)
  (l:(list a)), (list.Mem.mem x l) <-> (mem x (elements l)).

Axiom vertex : Type.
Parameter vertex_WhyType : WhyType vertex.
Existing Instance vertex_WhyType.

Parameter vertices: (set vertex).

Parameter successors: vertex -> (set vertex).

Axiom successors_vertices : forall (x:vertex), (mem x vertices) -> (subset
  (successors x) vertices).

(* Why3 assumption *)
Definition edge (x:vertex) (y:vertex): Prop := (mem x vertices) /\ (mem y
  (successors x)).

(* Why3 assumption *)
Inductive path: vertex -> (list vertex) -> vertex -> Prop :=
  | Path_empty : forall (x:vertex), (path x Init.Datatypes.nil x)
  | Path_cons : forall (x:vertex) (y:vertex) (z:vertex) (l:(list vertex)),
      (edge x y) -> ((path y l z) -> (path x (Init.Datatypes.cons x l) z)).

Axiom path_right_extension : forall (x:vertex) (y:vertex) (z:vertex)
  (l:(list vertex)), (path x l y) -> ((edge y z) -> (path x
  (Init.Datatypes.app l (Init.Datatypes.cons y Init.Datatypes.nil)) z)).

Axiom path_right_inversion : forall (x:vertex) (z:vertex) (l:(list vertex)),
  (path x l z) -> (((x = z) /\ (l = Init.Datatypes.nil)) \/ exists y:vertex,
  exists l':(list vertex), (path x l' y) /\ ((edge y z) /\
  (l = (Init.Datatypes.app l' (Init.Datatypes.cons y Init.Datatypes.nil))))).

Axiom path_trans : forall (x:vertex) (y:vertex) (z:vertex) (l1:(list vertex))
  (l2:(list vertex)), (path x l1 y) -> ((path y l2 z) -> (path x
  (Init.Datatypes.app l1 l2) z)).

Axiom empty_path : forall (x:vertex) (y:vertex), (path x Init.Datatypes.nil
  y) -> (x = y).

Axiom path_decomposition : forall (x:vertex) (y:vertex) (z:vertex)
  (l1:(list vertex)) (l2:(list vertex)), (path x
  (Init.Datatypes.app l1 (Init.Datatypes.cons y l2)) z) -> ((path x l1 y) /\
  (path y (Init.Datatypes.cons y l2) z)).

(* Why3 assumption *)
Definition reachable (x:vertex) (y:vertex): Prop := exists l:(list vertex),
  (path x l y).

(* Why3 assumption *)
Definition reachableplus (x:vertex) (y:vertex): Prop :=
  exists l:(list vertex), (~ (l = Init.Datatypes.nil)) /\ (path x l y).

(* Why3 assumption *)
Definition accessplus_to (s:(set vertex)) (y:vertex): Prop :=
  forall (x:vertex), (mem x s) -> (reachableplus x y).

(* Why3 assumption *)
Definition circle (x:vertex) (l:(list vertex)): Prop :=
  (~ (l = Init.Datatypes.nil)) /\ (path x l x).

(* Why3 assumption *)
Inductive env :=
  | mk_env : (set vertex) -> (set vertex) -> env.
Axiom env_WhyType : WhyType env.
Existing Instance env_WhyType.

(* Why3 assumption *)
Definition grays (v:env): (set vertex) :=
  match v with
  | (mk_env x x1) => x1
  end.

(* Why3 assumption *)
Definition blacks (v:env): (set vertex) :=
  match v with
  | (mk_env x x1) => x
  end.

(* Why3 assumption *)
Definition edges_in (s:(set vertex)): Prop := forall (x:vertex) (x':vertex),
  (mem x s) -> ((edge x x') -> (mem x' s)).

Axiom paths_in : forall (x:vertex) (l:(list vertex)) (z:vertex) (s:(set
  vertex)), (edges_in s) -> ((mem x s) -> ((path x l z) -> (mem z s))).

(* Why3 assumption *)
Definition wf_env (e:env): Prop :=
  match e with
  | (mk_env b g) => (subset g vertices) /\ ((subset b vertices) /\
      ((infix_eqeq (inter b g) (empty : (set vertex))) /\ (edges_in b)))
  end.

(* Why3 assumption *)
Definition subenv (e:env) (e':env): Prop := (subset (blacks e)
  (blacks e')) /\ (infix_eqeq (grays e) (grays e')).

(* Why3 assumption *)
Definition black_circle (x:vertex) (l:(list vertex)) (e:env): Prop := (circle
  x l) /\ (subset (elements l) (blacks e)).

Parameter r: (set vertex).

Parameter e: (set vertex).

Parameter e1: (set vertex).

Axiom H : (subset r vertices).

Axiom H1 : forall (x:vertex), (mem x r) -> (accessplus_to e1 x).

Axiom H2 : (wf_env (mk_env e e1)).

Axiom H3 : forall (x:vertex) (l:(list vertex)), ~ (black_circle x l (mk_env e
  e1)).

Axiom H4 : ~ (is_empty r).

Axiom H5 : ~ (mem (choose r) e1).

Axiom H6 : ~ (mem (choose r) e).

Parameter o: (set vertex).

Parameter o1: (set vertex).

Axiom H7 : (o = e) /\ (o1 = (add (choose r) e1)).

Axiom H8 : (subset (successors (choose r)) vertices).

Axiom H9 : forall (x:vertex), (mem x (successors (choose r))) ->
  (accessplus_to o1 x).

Axiom H10 : (wf_env (mk_env o o1)).

Axiom H11 : forall (x:vertex) (l:(list vertex)), ~ (black_circle x l
  (mk_env o o1)).

Parameter result: bool.

Parameter result1: (set vertex).

Parameter result2: (set vertex).

Axiom H12 : (wf_env (mk_env result1 result2)).

Axiom H13 : (subset o result1) /\ (infix_eqeq o1 result2).

Axiom H14 : (result = true) -> forall (x:vertex) (l:(list vertex)),
  ~ (black_circle x l (mk_env result1 result2)).

Axiom H15 : (infix_eqeq (inter (successors (choose r)) o1) (empty : (set
  vertex))).

Axiom H16 : (infix_eqeq (inter (successors (choose r)) (add (choose r) e1))
  (empty : (set vertex))).

Parameter o2: (set vertex).

Parameter o3: (set vertex).

Axiom H17 : (o2 = (add (choose r) result1)) /\ (o3 = (remove (choose r)
  result2)).

(* Why3 goal *)
Theorem WP_parameter_dfs : forall (x:(set vertex)) (x1:(set vertex)),
  ((mk_env o2 o3) = (mk_env x x1)) -> (edges_in x).
intros x x1 h1.

Qed.

